#include <stdio.h>
#include <EzGraph.h>
#include "config.h"
#include "layout.h"
#include "draw.h"
#include "obj_draw.h"
#include "gameend.h"
#include "gameover_draw.h"
#include "font.h"

static char *gameover_str = "げ　ー　む　お　ー　ば　ー";
static font_id_t *gameover_fontseq;

static char *menu_strs[] = {
	"[KeyR] りとらい",
	"[KeyQ] おわる",
};
#define MENU_NUM (sizeof(menu_strs)/sizeof(char*))
static font_id_t **menu_fontseqs;
static int menu_x[MENU_NUM];


void gameover_draw_init(void){
	int i;
	assert(MENU_NUM == gi_end);
	gameover_fontseq = alloc_fontseq(gameover_str);
	menu_fontseqs = alloc_fontseq_array(MENU_NUM);
	for (i = 0 ; i < MENU_NUM ; i++){
		menu_fontseqs[i] = alloc_fontseq(menu_strs[i]);
		menu_x[i] = GAMEOVER_LTX + 32 + i*((GAMEOVER_WIDTH-32+32)/MENU_NUM);
	}
}

void draw_gameover(void){
	int i;
	gameend_menuitem_t cmd;

	cmd = gameend_cmd();

	SetColor(7);
    EzFillBoxB(GAMEOVER_LTX-8, GAMEOVER_LTY-8, GAMEOVER_RBX+8, GAMEOVER_RBY+8);
    SetColor(0);
    EzFillBoxB(GAMEOVER_LTX, GAMEOVER_LTY, GAMEOVER_RBX, GAMEOVER_RBY);
	draw_fontseq(GAMEOVER_LTX+(GAMEOVER_WIDTH-16*13)/2, GAMEOVER_LTY+16, gameover_fontseq);
	for (i = 0 ; i < MENU_NUM ; i++){
		draw_fontseq(menu_x[i], GAMEOVER_RBY-16-16, menu_fontseqs[i]);
	}
	draw_img(ii_chee16_wr0,
			 RDX(menu_x[cmd]-20), RDY(GAMEOVER_RBY-16-12));
}

