#ifndef HOWTOPLAY_DRAW_H
#define HOWTOPLAY_DRAW_H
#include "config.h"
#include "obj.h"
#include "obj_draw.h"
#include "font.h"

typedef struct {
	char *key_str;
	char *description_game_str;
	char *description_menu_str;
	char *description_stage_select_str;
	font_id_t *key_fontseq;
    font_id_t *description_game_fontseq;
    font_id_t *description_menu_fontseq;
    font_id_t *description_stage_select_fontseq;
} key_info_t;

typedef struct object_info_s {
    obj_type_t type;
    char *name_str;
    char *description_str;
	int height;
    image_id_t img[16];
	void (*draw_func)(int, int, struct object_info_s *objinfo);
    int motion_interval, motion, motion_count;
    font_id_t *name_fontseq;
    font_id_t *description_fontseq;
} object_info_t;

/*
typedef struct {
    char *name_str;
    char *description_str;
	int height;
    image_id_t img[2];
    font_id_t *name_fontseq;
    font_id_t *description_fontseq;
} terran_info_t;
*/

void howtoplay_draw_init(void);
void draw_howtoplay(void);
void draw_rule(void);
void draw_keys(void);
void draw_objects(int obj_num, object_info_t obj_infos[]);

void draw_gadget_lift(int x, int y, object_info_t *objinfo);
void draw_gadget_aswitch(int x, int y, object_info_t *objinfo);

#endif
